#include <ansi_c.h>
#include <utility.h>
#include <rs232.h>
#include <cvirte.h>		
#include <userint.h>
#include "wireless.h"

int comport = 9;
static int panelHandle;

#define DimujPreklopnik(P) SetCtrlAttribute (panelHandle, PANEL_MODE##P, ATTR_DIMMED, 1);
//#define PANEL_MODE(P) PANEL_MODE##P

#define Resetuj(A,B) SetCtrlVal(panelHandle,PANEL_##A##B,0);
#define Setuj(A,B) SetCtrlVal(panelHandle,PANEL_##A##B,1);


#define Dimuj(A,B) SetCtrlAttribute (panelHandle, PANEL_##A##B, ATTR_DIMMED, 1);

#define OdDimujPreklopnik(P) SetCtrlAttribute (panelHandle, PANEL_MODE##P, ATTR_DIMMED, 0);

#define OdDimuj(A,B) SetCtrlAttribute (panelHandle, PANEL_##A##B, ATTR_DIMMED, 0);

#define OcitajPreklopnik(P)	GetCtrlVal(panelHandle,PANEL_MODE##P,&temp);
#define OcitajKontrolu(P) GetCtrlVal(panelHandle,PANEL_DOUT##P,&temp);

struct {char number;char state[3];} clients;

int main (int argc, char *argv[])
   {
   if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "wireless.uir", PANEL)) < 0)
		return -1;
	DisplayPanel (panelHandle);
	
	OpenComConfig (comport, "", 9600, 0, 8, 1, 512, 512);
	RunUserInterface ();
	CloseCom(comport);
	
	DiscardPanel (panelHandle);
	return 0;
}

int CVICALLBACK panelCB (int panel, int event, void *callbackData,int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_CLOSE:
	     {
		 QuitUserInterface (0);
		 break;
	  }  }
   return 0;
   }

int CVICALLBACK tick (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   char tx_buffer[3];
   char message[128];
   char rx_byte,data;
   char ramp;
   int temp;
   double t1,t2;
   //char message[128];
   switch (event)
      {
	  case EVENT_TIMER_TICK:
	     {
		 //t1 = Timer();
		 //FlushInQ(comport);
		 tx_buffer[0]=63;tx_buffer[1]=63;
		 ComWrt(comport,"??",2);
		 rx_byte = ComRdByte(comport);
		 //sprintf(message,"%d",rx_byte);
		 //MessagePopup(message,message);
		 for (ramp=clients.number+1;ramp<=rx_byte;ramp++)
		    { 
			switch (ramp)
			   {
			   case 1:OdDimujPreklopnik(1);break;
			   case 2:OdDimujPreklopnik(2);break;
			   case 3:OdDimujPreklopnik(3);break;
			   }
			tx_buffer[0]=ramp-1;tx_buffer[1]=0;//reset konfiguracije
			ComWrt(comport,tx_buffer,2);
			data = ComRdByte(comport);
			}				
		 clients.number=rx_byte;
		 /*for (ramp=1;ramp<=clients.number;ramp++)
		/   {
		    switch (ramp)
			   {
			   case 1:OcitajPreklopnik(1);break;case 2:OcitajPreklopnik(2);break;case 3:OcitajPreklopnik(3);break;
			   }
		 	if (clients.state[ramp-1]!=temp)
			   {
			   switch (clients.state[ramp-1] )
			      {
			      case 0: break;
				  case 1: 
			         {
					 switch (ramp)
					    {
			            case 1:Resetuj(ANIN,1);Dimuj(ANIN,1);break;case 2:Resetuj(ANIN,2);Dimuj(ANIN,2);break;case 3:Resetuj(ANIN,3);Dimuj(ANIN,3);break;
			            }	 
					 break;
					 }
				  case 2:
			         {
					 switch (ramp)
					    {
			            case 1:Resetuj(DIN,1);Dimuj(DIN,1);break;case 2:Resetuj(DIN,2);Dimuj(DIN,2);break;case 3:Resetuj(DIN,3);Dimuj(DIN,3);break;
			            }	 
					 break;
					 }					  
				  case 3:
			         {
					 switch (ramp)
					    {
			            case 1:Resetuj(DOUT,1);Dimuj(DOUT,1);break;case 2:Resetuj(DOUT,2);Dimuj(DOUT,2);break;case 3:Resetuj(DOUT,3);Dimuj(DOUT,3);break;
			            }	 
					 break;
			   	  }	 }
			   clients.state[ramp-1]=temp;
			   tx_buffer[0]=ramp-1;
			   switch (clients.state[ramp-1] )
			      {
			      case 0: tx_buffer[1]=0x00;break;
				  case 1: 
			         {
					 tx_buffer[1]=0x03;	 
					 switch (ramp)
					    {
			            case 1:OdDimuj(ANIN,1);break;case 2:OdDimuj(ANIN,2);break;case 3:OdDimuj(ANIN,3);break;
			            }	 
					 break;
					 }
				  case 2:
			         {
					 tx_buffer[1]=0x02;
					 switch (ramp)
					    {
			            case 1:OdDimuj(DIN,1);break;case 2:OdDimuj(DIN,2);break;case 3:OdDimuj(DIN,3);break;
			            }	 
					 break;
					 }					  
				  case 3:
			         {
				     tx_buffer[1]=0x01;		 
					 switch (ramp)
					    {
			            case 1:OdDimuj(DOUT,1);break;case 2:OdDimuj(DOUT,2);break;case 3:OdDimuj(DOUT,3);break;
			            }	 
					 break;
			   	  }	 }
			   ComWrt(8,tx_buffer,2);
			   }
			else // nije promenjen preklopnik
			   {
			   switch (clients.state[ramp-1] ) 
			      {
			      case 0:break;
				  case 1:break;
				  case 2:
				     {
                     tx_buffer[0]=ramp-1;tx_buffer[1]=0x07;ComWrt(8,tx_buffer,2);
					 rx_byte=ComRdByte(8);
					 if (rx_byte=='A') 
					    {
						switch (ramp)
						   {
						   case 1:Setuj(DIN,1);break;case 2:Setuj(DIN,2);break;case 3:Setuj(DIN,3);break;
						}  }
					 else 
					    {
						switch (ramp)
						   {
						   case 1:Resetuj(DIN,1);break;case 2:Resetuj(DIN,2);break;case 3:Resetuj(DIN,3);break;
						}  }
					 break;
					 }
				  case 3:
					 {
				     tx_buffer[0]=ramp-1;
					 switch (ramp)
					    {
					    case 1:OcitajKontrolu(1);break;case 2:OcitajKontrolu(2);break;case 3:OcitajKontrolu(3);break;
						}
					 
					 //GetCtrlVal(panelHandle,PANEL_DOUT1,&temp);
					 if (temp) tx_buffer[1]=0x05;
					 else tx_buffer[1]=0x04;
					 ComWrt(8,tx_buffer,2);	 	 
					 break;		 
			   }  }  }  
			Delay(0.2);
			FlushInQ(8);
			}			   */
		 
		 if (clients.number) //ima bar jedan
		    {
			GetCtrlVal(panelHandle,PANEL_MODE1,&temp);
			if (clients.state[0]!=temp)//promenjen
			   {
			   switch (clients.state[0])
			      {
			      case 0: break;
				  case 1: {SetCtrlVal(panelHandle,PANEL_ANIN1,0.0);SetCtrlAttribute (panelHandle, PANEL_ANIN1, ATTR_DIMMED, 1);break;}
				  case 2: {SetCtrlVal(panelHandle,PANEL_DIN1,0);SetCtrlAttribute (panelHandle, PANEL_DIN1, ATTR_DIMMED, 1);break;}
				  case 3: {SetCtrlVal(panelHandle,PANEL_DOUT1,0);SetCtrlAttribute (panelHandle, PANEL_DOUT1, ATTR_DIMMED, 1);break;}
				  }
			   clients.state[0]=temp;
			   tx_buffer[0]=0x00;
			   switch (clients.state[0]) 
			      {
			      case 0: //ugasen
				     {
					 //MessagePopup("","resetovan prvi"); 
					 tx_buffer[1]=0x00;break; 	 
					 }
				  case 1: //analog in
					 {
					// MessagePopup("","analogni ulaz prvi"); 
						 SetCtrlAttribute (panelHandle, PANEL_ANIN1, ATTR_DIMMED, 0);tx_buffer[1]=0x03;
					 break;
					 }
				  case 2: //digital in
					 {
						// MessagePopup("","digitalni ulaz prvi"); 
					 SetCtrlAttribute (panelHandle, PANEL_DIN1, ATTR_DIMMED, 0); tx_buffer[1]=0x02;
					 break;
					 }
				  case 3: //digital out
					 {
					 // MessagePopup("","digitalni izlaz prvi"); 
					 SetCtrlAttribute (panelHandle, PANEL_DOUT1, ATTR_DIMMED, 0);tx_buffer[1]=0x01;break;
				  }  }
			   ComWrt(comport,tx_buffer,2);
			   data = ComRdByte(comport);
			   }
		    else //nije promenjen mode
			   {
			   tx_buffer[0]=0x00;	   
			   switch (clients.state[0])
			      {
			      case 0:break;
				  case 1: 
					 {
					 
					 break;
					 }
				  case 2: //digitalni ulaz citanje
					 {
						// MessagePopup("","citanje DIN prvi"); 
					 tx_buffer[1]=0x07;ComWrt(comport,tx_buffer,2);
					 data = ComRdByte(comport);
					 rx_byte=ComRdByte(comport);
					 if (rx_byte=='A') SetCtrlVal(panelHandle,PANEL_DIN1,1);
					 else SetCtrlVal(panelHandle,PANEL_DIN1,0);	 
					 break;
					 }
				  case 3://Digital Out
					 {
						// MessagePopup("","citanje DOUT prvi"); 
					 GetCtrlVal(panelHandle,PANEL_DOUT1,&temp);
					 if (temp) tx_buffer[1]=0x05;
					 else tx_buffer[1]=0x04;
					 ComWrt(comport,tx_buffer,2);
					 data = ComRdByte(comport);
					 break;
			}  }  }  }  
		 if (clients.number>1) //ima bar dva
		    {
			GetCtrlVal(panelHandle,PANEL_MODE2,&temp);
			if (clients.state[1]!=temp)//promenjen
			   {
			   switch (clients.state[1])
			      {
			      case 0: break;
				  case 1: {SetCtrlVal(panelHandle,PANEL_ANIN2,0.0);SetCtrlAttribute (panelHandle, PANEL_ANIN2, ATTR_DIMMED, 1);break;}
				  case 2: {SetCtrlVal(panelHandle,PANEL_DIN2,0);SetCtrlAttribute (panelHandle, PANEL_DIN2, ATTR_DIMMED, 1);break;}
				  case 3: {SetCtrlVal(panelHandle,PANEL_DOUT2,0);SetCtrlAttribute (panelHandle, PANEL_DOUT2, ATTR_DIMMED, 1);break;}
				  }
			   clients.state[1]=temp;
			   tx_buffer[0]=0x01;
			   switch (clients.state[1]) 
			      {
			      case 0: //ugasen
				     {
					// MessagePopup("","resetovan drugi"); 	 
					 tx_buffer[1]=0x00;break; 	 
					 }
				  case 1: //analog in
					 {
					//	 MessagePopup("","analogni ulaz drugi"); 
					 SetCtrlAttribute (panelHandle, PANEL_ANIN2, ATTR_DIMMED, 0);tx_buffer[1]=0x03;
					 break;
					 }
				  case 2: //digital in
					 {
					// MessagePopup("","digitalni ulaz drugi"); 	 
					 SetCtrlAttribute (panelHandle, PANEL_DIN2, ATTR_DIMMED, 0); tx_buffer[1]=0x02;
					 break;
					 }
				  case 3: //digital out
					 {
					// MessagePopup("","digitalni izlaz drugi"); 	 
					 SetCtrlAttribute (panelHandle, PANEL_DOUT2, ATTR_DIMMED, 0);tx_buffer[1]=0x01;break;
				  }  }
			   ComWrt(comport,tx_buffer,2);
			   data = ComRdByte(comport);
			   }
		    else //nije promenjen mode
			   {
			   switch (clients.state[1])
			      {
			      case 0:break;
				  case 1: 
					 {
					 
					 break;
					 }
				  case 2: //digitalni ulaz citanje
					 {
				    // MessagePopup("","citanje DIN drugi"); 
					 tx_buffer[0]=0x01;tx_buffer[1]=0x07;ComWrt(comport,tx_buffer,2);
					 data = ComRdByte(comport);
					 rx_byte=ComRdByte(comport);
					 if (rx_byte=='A') SetCtrlVal(panelHandle,PANEL_DIN2,1);
					 else SetCtrlVal(panelHandle,PANEL_DIN2,0);	 
					 break;
					 }
				  case 3://Digital Out
					 {
					//	 MessagePopup("","DOUT drugi"); 
					 tx_buffer[0]=0x01;
					 GetCtrlVal(panelHandle,PANEL_DOUT2,&temp);
					 if (temp) tx_buffer[1]=0x05;
					 else tx_buffer[1]=0x04;
					 ComWrt(comport,tx_buffer,2);
					 data = ComRdByte(comport);
					 break;
			}  }  }  } 
		 //t2=Timer();
		 //t2=t2-t1;
		 //sprintf(message,"%f",t2);
		 //MessagePopup(message,message);
		 break;
	  }  
		 }  
   return 0;
   }
